<?php

    class xx_dz_members{ // dz数据库用户数据
    
        /**
         * 检测积分下限是否够积分扣除
         * @param $action // array(2=>100) 其中2为extcredits积分编号，100为需要扣除的积分数量
         * @param $uid //用户uid
         * @return bool //如果积分大于或等于所要扣除积分，则返回真，如果不够扣除则返回假
         */
        public static function check_credits_limit($action,$uid){
            $data  = false;
            if (is_array($action)){
                foreach ($action as $key => $value){
                    $credits = DB::result_first('SELECT '.'extcredits'.$key.' FROM %t WHERE uid=%d',array('common_member_count',$uid));
                    $credits - $value >= 0 ? $data =  true :$data = false;
                }
                return $data;
            }else{
                return false;
            }
        }
    
        /**
         * 验证用户账号密码是否正确，正确返回uid；
         * @param $username
         * @param $password
         * @return array|false|mixed
         */
        public static function user_login_uc($username,$password){
    
            $uid = xx_dz_members::get_by_uid($username,'uid');
            
            $uid_login = uc_user_login($uid,$password,1,0);
    
            if($uid_login[0] > 0) {
                return $uid_login[0];
            } elseif($uid_login[0] == -1) {
                xx_client::json_output(400,'error0011');
            } elseif($uid_login[0] == -2) {
                xx_client::json_output(400,'error0012');
            } elseif($uid_login[0] == -3) {
                xx_client::json_output(400,'error00118');
            } else {
                xx_client::json_output(400,'error0013');
            }
        }
        
        /**
         * 用户注册，自动激活dz用户数据
         * @param $uid
         * @param $username
         * @param $password
         * @param $email
         */
        public static function login_dz_register($uid,$username,$password,$email){
            global $_G;
            $salt = DB::result_first('SELECT salt FROM %t WHERE uid=%d',array('ucenter_members',$uid));
            $passwordmd5 = md5(md5($password).$salt);
            $member =array(
                'uid'=>$uid,
                'username'=>$username,
                'password'=>$passwordmd5,
                'email'=>$email,
                'adminid'=>0,
                'groupid'=>10,
                'regdate'=>time(),
                'credits'=>0,
                'timeoffset'=>9999
            );
    
            DB::insert('common_member',$member,true,true,'');
    
            $status =array(
                'uid'=>$uid,
                'regip'=>$_G['clientip'] ,
                'lastip'=>$_G['clientip'] ,
                'lastvisit'=>time(),
                'lastactivity'=>time(),
                'lastpost'=>0,
                'lastsendmail'=>0
            );
            DB::insert('common_member_status',$status,true,true,'');
            $profile =array(
                'uid'=>$uid,
            );
            DB::insert('common_member_profile',$profile,true,true,'');
            $forum=array(
                'uid'=>$uid,
            );
            DB::insert('common_member_field_forum',$forum,true,true,'');
            $home=array(
                'uid'=>$uid,
            );
            DB::insert('common_member_field_home',$home,true,true,'');
            $count=array(
                'uid'=>$uid,
                'extcredits1'=>0,
                'extcredits2'=>0,
                'extcredits3'=>0,
                'extcredits4'=>0,
                'extcredits5'=>0,
                'extcredits6'=>0,
                'extcredits7'=>0,
                'extcredits8'=>0,
            );
            DB::insert('common_member_count',$count,true,true,'');
        }
        /**
         * 通过uid获取uc用户数据
         * @param $uid
         * @param $ziduan
          uid	mediumint(8) unsigned		NO	是	用户ID
        username	char(15)		NO		用户名
        password	char(32)		NO		密码
        email	char(32)		NO		用户Email
        myid	char(30)		NO		漫游id
        myidkey	char(16)		NO		漫游id
        regip	char(15)		NO		注册IP
        regdate	int(10) unsigned	0	NO		注册时间
        lastloginip	int(10)	0	NO		上次登陆的IP(程序转换成数值类型)
        lastlogintime	int(10) unsigned	0	NO		上次登录的时间
        salt	char(6)		NO		密码干扰串，用来和密码进行配合验证，防止被暴力破解
        secques	char(8)		NO		用户的安全提问
         */
        public static function uc_by_uid($uid,$ziduan=''){
            $data = DB::fetch_first('select * from %t where uid=%d',array('ucenter_members',$uid));
            if ($ziduan){
                return $data[$ziduan];
            }else{
                return $data;
            }
        }
    
    
        /**
         * 返回用户登录名（uid、username、email、sgin、qq、weixin、phone）
         * @param $name //输入uid、username、email、sgin、qq、weixin、phone
         * @param string $type //定义输出内容 uid、username、email、sgin、qq、weixin、phone 为空返回全部
         * @param string $output //定义查询为空时，是否直接退出程序，默认假
         * @return array|false|mixed //失败返回假(未激活账号无法查询)
         */
        
        public static function get_by_uid($name,$type='',$output = false){
            
            if (empty($name)){ //判断如果是空就返回假
                return  false;
            }
            
            $name =trim($name);
            $data_xinxiu  = DB::fetch_first('SELECT * FROM %t WHERE (sgin=%s or qq=%s or weixin=%s or phone=%s) and type=1',array('xinxiu_network_members',$name,$name,$name,$name));
            if ($data_xinxiu['uid']){
                $data  = DB::fetch_first('SELECT * FROM %t WHERE uid=%s',array('ucenter_members',$data_xinxiu['uid']));
                $data = array_merge($data,$data_xinxiu);
            }else{
                $data  = DB::fetch_first('SELECT * FROM %t WHERE username=%s or email=%s ',array('ucenter_members',$name,$name));
                if ($data['uid']){
                    $data_xinxiu  = DB::fetch_first('SELECT * FROM %t  WHERE uid=%d and type=1',array('xinxiu_network_members',$data['uid']));
                    $data = array_merge($data,$data_xinxiu);
                }
            }
            if (empty($data['uid'])){
                $data  = DB::fetch_first('SELECT * FROM %t WHERE uid=%d ',array('ucenter_members',$name));
                if ($data['uid']){
                    $data_xinxiu  = DB::fetch_first('SELECT * FROM %t  WHERE uid=%d and type=1',array('xinxiu_network_members',$data['uid']));
                    $data = array_merge($data,$data_xinxiu);
                }
            }
            
            if ($data){
                if (empty($type)){
                    return $data;
                }elseif ($type == 'email'){
                    return $data['email'];
                }elseif ($type == 'username'){
                    return $data['username'];
                }elseif ($type == 'sgin'){
                    return $data['sgin'];
                }elseif ($type == 'qq'){
                    return $data['qq'];
                }elseif ($type == 'weixin'){
                    return $data['weixin'];
                }elseif ($type == 'phone'){
                    return $data['phone'];
                }else{
                    return $data['uid'];
                }
            }else{
                if ($output){
                    xx_client::json_output('400','error00122');
                }else{
                    return false;
                }
            }

        }
        
        
        /**
         * 返回启用积分信息
         * @param $int //积分类型id 1-8
         * @param string $type //返回类型字段 默认返回title
         * @return mixed
         */
        public static function extcredits($int,$type = 'title'){
            $data = xx_cache::get_cache('discuz/extcredits',array($int,$type));
            return $data;
        }
        
        /**
         * 通过用户组id，返回用户组信息表
         * @param $int //用户组id
         * @param null $type // 如果是空返回对应用户组id所有字段，如果填写字段则返回对应字段信息
         * @return mixed
         */
        public static function usergroup($int,$type = null){
            $arr = xx_cache::get_cache('discuz/usergroup');
            if (empty($type)){
                return $arr[$int-1];
            }else{
                return $arr[$int-1][$type];
            }
        }
    
    
        /**
         * 通过uid获取用户会员组groupid
         * @param $uid
         * @return mixed 返回用户组id
         */
        public static function usergroup_by_uid($uid){
            $data = DB::result_first('select groupid from %t where uid=%d',array('common_member',$uid));
            return $data;
        }
    
        /**
         * 通过uid获取用户管理组adminid
         * @param $uid
         * @return mixed 返回管理组id
         */
        public static function adminid_by_uid($uid){
            $data = DB::result_first('select adminid from %t where uid=%d',array('common_member',$uid));
            return $data;
        }
    }